﻿// <auto-generated />
using System;
using Microsoft.EntityFrameworkCore;
using Microsoft.EntityFrameworkCore.Infrastructure;
using Microsoft.EntityFrameworkCore.Storage.ValueConversion;
using ReportsDAL;

#nullable disable

namespace ReportsDAL.Migrations
{
    [DbContext(typeof(CourseStorageContext))]
    partial class CourseStorageContextModelSnapshot : ModelSnapshot
    {
        protected override void BuildModel(ModelBuilder modelBuilder)
        {
#pragma warning disable 612, 618
            modelBuilder
                .HasAnnotation("ProductVersion", "6.0.10")
                .HasAnnotation("Relational:MaxIdentifierLength", 64);

            modelBuilder.Entity("ReportsDAL.Models.CourseStartType", b =>
                {
                    b.Property<ulong>("CourseStartTypeId")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("bigint unsigned");

                    b.Property<string>("StartTypeName")
                        .IsRequired()
                        .HasMaxLength(70)
                        .HasColumnType("varchar(70)");

                    b.HasKey("CourseStartTypeId");

                    b.ToTable("CourseStartTypes");
                });

            modelBuilder.Entity("ReportsDAL.Models.DataSetTable", b =>
                {
                    b.Property<ulong>("DataSetTableId")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("bigint unsigned");

                    b.Property<ulong>("EducationGroupId")
                        .HasColumnType("bigint unsigned");

                    b.Property<string>("Email")
                        .IsRequired()
                        .HasMaxLength(70)
                        .HasColumnType("varchar(70)");

                    b.Property<string>("FullName")
                        .IsRequired()
                        .HasMaxLength(100)
                        .HasColumnType("varchar(100)");

                    b.Property<DateTime>("ReleaseDate")
                        .HasColumnType("datetime(6)");

                    b.Property<int>("Score")
                        .HasColumnType("int");

                    b.Property<string>("Submodule")
                        .IsRequired()
                        .HasMaxLength(100)
                        .HasColumnType("varchar(100)");

                    b.Property<string>("TaskName")
                        .IsRequired()
                        .HasMaxLength(100)
                        .HasColumnType("varchar(100)");

                    b.HasKey("DataSetTableId");

                    b.HasIndex("EducationGroupId");

                    b.ToTable("DataSetTables");
                });

            modelBuilder.Entity("ReportsDAL.Models.EducationCourse", b =>
                {
                    b.Property<ulong>("EducationCourseId")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("bigint unsigned");

                    b.Property<string>("EducationCourseName")
                        .IsRequired()
                        .HasMaxLength(70)
                        .HasColumnType("varchar(70)");

                    b.HasKey("EducationCourseId");

                    b.ToTable("EducationCourses");
                });

            modelBuilder.Entity("ReportsDAL.Models.EducationCourseResult", b =>
                {
                    b.Property<ulong>("EducationCourseResultId")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("bigint unsigned");

                    b.Property<string>("BlockName")
                        .IsRequired()
                        .HasMaxLength(100)
                        .HasColumnType("varchar(100)");

                    b.Property<int>("BlockNestingLevel")
                        .HasColumnType("int");

                    b.Property<string>("BlockType")
                        .IsRequired()
                        .HasMaxLength(100)
                        .HasColumnType("varchar(100)");

                    b.Property<DateTime?>("CompletedOn")
                        .HasColumnType("datetime(6)");

                    b.Property<ulong>("EducationCourseId")
                        .HasColumnType("bigint unsigned");

                    b.Property<string>("Email")
                        .IsRequired()
                        .HasMaxLength(100)
                        .HasColumnType("varchar(100)");

                    b.Property<string>("FullName")
                        .IsRequired()
                        .HasMaxLength(100)
                        .HasColumnType("varchar(100)");

                    b.Property<int?>("Grade")
                        .HasColumnType("int");

                    b.Property<string>("Mentor")
                        .HasMaxLength(250)
                        .HasColumnType("varchar(250)");

                    b.Property<string>("ParticipantGroup")
                        .IsRequired()
                        .HasMaxLength(100)
                        .HasColumnType("varchar(100)");

                    b.Property<int?>("Progress")
                        .HasColumnType("int");

                    b.Property<string>("Reviewer")
                        .IsRequired()
                        .HasMaxLength(100)
                        .HasColumnType("varchar(100)");

                    b.Property<int?>("Score")
                        .HasColumnType("int");

                    b.Property<DateTime?>("StartedOn")
                        .HasColumnType("datetime(6)");

                    b.Property<string>("Status")
                        .HasMaxLength(100)
                        .HasColumnType("varchar(100)");

                    b.Property<DateTime?>("UpdatedOn")
                        .HasColumnType("datetime(6)");

                    b.HasKey("EducationCourseResultId");

                    b.HasIndex("EducationCourseId");

                    b.ToTable("EducationCourseResults");
                });

            modelBuilder.Entity("ReportsDAL.Models.EducationGroup", b =>
                {
                    b.Property<ulong>("EducationGroupId")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("bigint unsigned");

                    b.Property<ulong?>("CourseStartTypeId")
                        .HasColumnType("bigint unsigned");

                    b.Property<string>("EducationGroupName")
                        .IsRequired()
                        .HasMaxLength(70)
                        .HasColumnType("varchar(70)");

                    b.Property<DateTime>("StartedAt")
                        .HasColumnType("datetime(6)");

                    b.HasKey("EducationGroupId");

                    b.HasIndex("CourseStartTypeId");

                    b.ToTable("EducationGroups");
                });

            modelBuilder.Entity("ReportsDAL.Models.Location", b =>
                {
                    b.Property<ulong>("LocationId")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("bigint unsigned");

                    b.Property<string>("LocationName")
                        .IsRequired()
                        .HasMaxLength(70)
                        .HasColumnType("varchar(70)");

                    b.Property<string>("ShortName")
                        .IsRequired()
                        .HasMaxLength(20)
                        .HasColumnType("varchar(20)");

                    b.HasKey("LocationId");

                    b.ToTable("Locations");
                });

            modelBuilder.Entity("ReportsDAL.Models.MeetingParticipant", b =>
                {
                    b.Property<ulong>("MeetingParticipantId")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("bigint unsigned");

                    b.Property<DateTime>("Duration")
                        .HasColumnType("datetime(6)");

                    b.Property<string>("Email")
                        .IsRequired()
                        .HasMaxLength(70)
                        .HasColumnType("varchar(70)");

                    b.Property<string>("FullName")
                        .IsRequired()
                        .HasMaxLength(100)
                        .HasColumnType("varchar(100)");

                    b.Property<DateTime>("JoinTime")
                        .HasColumnType("datetime(6)");

                    b.Property<DateTime>("LeaveTime")
                        .HasColumnType("datetime(6)");

                    b.Property<ulong>("MeetingSummaryId")
                        .HasColumnType("bigint unsigned");

                    b.Property<string>("ParticipantGUID")
                        .HasColumnType("longtext");

                    b.Property<string>("Role")
                        .IsRequired()
                        .HasMaxLength(70)
                        .HasColumnType("varchar(70)");

                    b.HasKey("MeetingParticipantId");

                    b.HasIndex("MeetingSummaryId");

                    b.ToTable("MeetingParticipants");
                });

            modelBuilder.Entity("ReportsDAL.Models.MeetingSummary", b =>
                {
                    b.Property<ulong>("MeetingSummaryId")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("bigint unsigned");

                    b.Property<ulong>("EducationGroupId")
                        .HasColumnType("bigint unsigned");

                    b.Property<string>("LectorEmail")
                        .HasColumnType("longtext");

                    b.Property<ulong>("LectorId")
                        .HasColumnType("bigint unsigned");

                    b.Property<DateTime>("MeetingEndTime")
                        .HasColumnType("datetime(6)");

                    b.Property<string>("MeetingGUID")
                        .HasColumnType("longtext");

                    b.Property<DateTime>("MeetingStartTime")
                        .HasColumnType("datetime(6)");

                    b.Property<string>("MeetingTitle")
                        .HasMaxLength(120)
                        .HasColumnType("varchar(120)");

                    b.Property<uint>("ParticipantsTotalNumber")
                        .HasColumnType("int unsigned");

                    b.HasKey("MeetingSummaryId");

                    b.HasIndex("EducationGroupId");

                    b.ToTable("MeetingSummaries");
                });

            modelBuilder.Entity("ReportsDAL.Models.Participant", b =>
                {
                    b.Property<ulong>("ParticipantId")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("bigint unsigned");

                    b.Property<bool>("Active")
                        .HasColumnType("tinyint(1)");

                    b.Property<string>("AlternateEmail")
                        .HasMaxLength(70)
                        .HasColumnType("varchar(70)");

                    b.Property<string>("Comments")
                        .HasMaxLength(250)
                        .HasColumnType("varchar(250)");

                    b.Property<string>("DismissReason")
                        .HasMaxLength(200)
                        .HasColumnType("varchar(200)");

                    b.Property<ulong>("EducationGroupId")
                        .HasColumnType("bigint unsigned");

                    b.Property<string>("Email")
                        .HasColumnType("longtext");

                    b.Property<string>("EnglishLevel")
                        .HasMaxLength(70)
                        .HasColumnType("varchar(70)");

                    b.Property<string>("FinalTaskLink")
                        .HasMaxLength(250)
                        .HasColumnType("varchar(250)");

                    b.Property<string>("FinalTaskName")
                        .HasMaxLength(250)
                        .HasColumnType("varchar(250)");

                    b.Property<string>("FullName")
                        .IsRequired()
                        .HasMaxLength(70)
                        .HasColumnType("varchar(70)");

                    b.Property<string>("GitNick")
                        .HasMaxLength(70)
                        .HasColumnType("varchar(70)");

                    b.Property<ulong?>("RegionId")
                        .HasColumnType("bigint unsigned");

                    b.Property<string>("RegionName")
                        .HasMaxLength(100)
                        .HasColumnType("varchar(100)");

                    b.Property<ulong?>("StudentStateId")
                        .HasMaxLength(70)
                        .HasColumnType("bigint unsigned");

                    b.Property<string>("TeamsEmail")
                        .HasMaxLength(70)
                        .HasColumnType("varchar(70)");

                    b.HasKey("ParticipantId");

                    b.HasIndex("EducationGroupId");

                    b.HasIndex("RegionId");

                    b.HasIndex("StudentStateId");

                    b.ToTable("Participants");
                });

            modelBuilder.Entity("ReportsDAL.Models.Region", b =>
                {
                    b.Property<ulong>("RegionId")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("bigint unsigned");

                    b.Property<ulong>("LocationId")
                        .HasColumnType("bigint unsigned");

                    b.Property<string>("RegionName")
                        .IsRequired()
                        .HasMaxLength(100)
                        .HasColumnType("varchar(100)");

                    b.HasKey("RegionId");

                    b.HasIndex("LocationId");

                    b.ToTable("Regions");
                });

            modelBuilder.Entity("ReportsDAL.Models.StudentState", b =>
                {
                    b.Property<ulong>("StudentStateId")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("bigint unsigned");

                    b.Property<string>("StateName")
                        .IsRequired()
                        .HasMaxLength(70)
                        .HasColumnType("varchar(70)");

                    b.HasKey("StudentStateId");

                    b.ToTable("StudentStates");
                });

            modelBuilder.Entity("ReportsDAL.Models.Submodule", b =>
                {
                    b.Property<ulong>("SubmoduleId")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("bigint unsigned");

                    b.Property<ulong>("EducationCourseId")
                        .HasColumnType("bigint unsigned");

                    b.Property<uint>("MinTaskNumber")
                        .HasColumnType("int unsigned");

                    b.Property<string>("SubmoduleName")
                        .IsRequired()
                        .HasMaxLength(100)
                        .HasColumnType("varchar(100)");

                    b.Property<uint>("TotalTasksNumber")
                        .HasColumnType("int unsigned");

                    b.HasKey("SubmoduleId");

                    b.HasIndex("EducationCourseId");

                    b.ToTable("Submodules");
                });

            modelBuilder.Entity("ReportsDAL.Models.TaskMinLevel", b =>
                {
                    b.Property<ulong>("TaskMinLevelId")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("bigint unsigned");

                    b.Property<uint>("Score")
                        .HasColumnType("int unsigned");

                    b.Property<string>("Submodule")
                        .IsRequired()
                        .HasMaxLength(100)
                        .HasColumnType("varchar(100)");

                    b.Property<ulong?>("SubmoduleId")
                        .HasColumnType("bigint unsigned");

                    b.Property<string>("TaskName")
                        .IsRequired()
                        .HasMaxLength(150)
                        .HasColumnType("varchar(150)");

                    b.HasKey("TaskMinLevelId");

                    b.HasIndex("SubmoduleId");

                    b.ToTable("TaskMinLevels");
                });

            modelBuilder.Entity("ReportsDAL.Models.DataSetTable", b =>
                {
                    b.HasOne("ReportsDAL.Models.EducationGroup", "EducationGroup")
                        .WithMany("DataSetTables")
                        .HasForeignKey("EducationGroupId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();

                    b.Navigation("EducationGroup");
                });

            modelBuilder.Entity("ReportsDAL.Models.EducationCourseResult", b =>
                {
                    b.HasOne("ReportsDAL.Models.EducationCourse", "EducationCourse")
                        .WithMany("EducationCourseResults")
                        .HasForeignKey("EducationCourseId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();

                    b.Navigation("EducationCourse");
                });

            modelBuilder.Entity("ReportsDAL.Models.EducationGroup", b =>
                {
                    b.HasOne("ReportsDAL.Models.CourseStartType", "CourseStartType")
                        .WithMany("EducationGroups")
                        .HasForeignKey("CourseStartTypeId");

                    b.Navigation("CourseStartType");
                });

            modelBuilder.Entity("ReportsDAL.Models.MeetingParticipant", b =>
                {
                    b.HasOne("ReportsDAL.Models.MeetingSummary", "MeetingSummary")
                        .WithMany("MeetingParticipants")
                        .HasForeignKey("MeetingSummaryId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();

                    b.Navigation("MeetingSummary");
                });

            modelBuilder.Entity("ReportsDAL.Models.MeetingSummary", b =>
                {
                    b.HasOne("ReportsDAL.Models.EducationGroup", "EducationGroup")
                        .WithMany("MeetingSummaries")
                        .HasForeignKey("EducationGroupId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();

                    b.Navigation("EducationGroup");
                });

            modelBuilder.Entity("ReportsDAL.Models.Participant", b =>
                {
                    b.HasOne("ReportsDAL.Models.EducationGroup", "EducationGroup")
                        .WithMany("Participants")
                        .HasForeignKey("EducationGroupId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();

                    b.HasOne("ReportsDAL.Models.Region", "Region")
                        .WithMany("Participants")
                        .HasForeignKey("RegionId");

                    b.HasOne("ReportsDAL.Models.StudentState", "StudentState")
                        .WithMany("Participants")
                        .HasForeignKey("StudentStateId");

                    b.Navigation("EducationGroup");

                    b.Navigation("Region");

                    b.Navigation("StudentState");
                });

            modelBuilder.Entity("ReportsDAL.Models.Region", b =>
                {
                    b.HasOne("ReportsDAL.Models.Location", "Location")
                        .WithMany("Regions")
                        .HasForeignKey("LocationId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();

                    b.Navigation("Location");
                });

            modelBuilder.Entity("ReportsDAL.Models.Submodule", b =>
                {
                    b.HasOne("ReportsDAL.Models.EducationCourse", "EducationCourse")
                        .WithMany("Submodules")
                        .HasForeignKey("EducationCourseId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();

                    b.Navigation("EducationCourse");
                });

            modelBuilder.Entity("ReportsDAL.Models.TaskMinLevel", b =>
                {
                    b.HasOne("ReportsDAL.Models.Submodule", null)
                        .WithMany("TaskMinLevels")
                        .HasForeignKey("SubmoduleId");
                });

            modelBuilder.Entity("ReportsDAL.Models.CourseStartType", b =>
                {
                    b.Navigation("EducationGroups");
                });

            modelBuilder.Entity("ReportsDAL.Models.EducationCourse", b =>
                {
                    b.Navigation("EducationCourseResults");

                    b.Navigation("Submodules");
                });

            modelBuilder.Entity("ReportsDAL.Models.EducationGroup", b =>
                {
                    b.Navigation("DataSetTables");

                    b.Navigation("MeetingSummaries");

                    b.Navigation("Participants");
                });

            modelBuilder.Entity("ReportsDAL.Models.Location", b =>
                {
                    b.Navigation("Regions");
                });

            modelBuilder.Entity("ReportsDAL.Models.MeetingSummary", b =>
                {
                    b.Navigation("MeetingParticipants");
                });

            modelBuilder.Entity("ReportsDAL.Models.Region", b =>
                {
                    b.Navigation("Participants");
                });

            modelBuilder.Entity("ReportsDAL.Models.StudentState", b =>
                {
                    b.Navigation("Participants");
                });

            modelBuilder.Entity("ReportsDAL.Models.Submodule", b =>
                {
                    b.Navigation("TaskMinLevels");
                });
#pragma warning restore 612, 618
        }
    }
}
